##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate image conversion from JPG, ##
## PNG, GIF, etc. into C-arrays.                                          ##
############################################################################

##
## NEW MACROS
##

## 16 colours palette
#PALETTE=0 1 2 3 6 9 11 12 13 15 16 18 20 24 25 26

## Default values
#$(eval $(call IMG2SP, SET_MODE        , 0                  ))  { 0, 1, 2 }
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
#$(eval $(call IMG2SP, SET_FOLDER      , src/               ))
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))	{ sprites, zgtiles, screen }
#$(eval $(call IMG2SP, SET_OUTPUT      , c                  ))  { bin, c }
#$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
#$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))
#$(eval $(call IMG2SP, CONVERT         , img.png , w, h, array, palette, tileset))

PALETTE= 16 0 1 3 6 12 9 11 13 15 22 21 25 23 24 26
$(eval $(call IMG2SP, SET_MODE, 0))
$(eval $(call IMG2SP, SET_FOLDER, src/sprites/))
$(eval $(call IMG2SP, SET_PALETTE_FW, $(PALETTE)))
## Hero sprites
$(eval $(call IMG2SP, CONVERT, assets/hero_r0.png, 8, 12, sprite_hero_r0, palette,))
$(eval $(call IMG2SP, CONVERT, assets/hero_l0.png, 8, 12, sprite_hero_l0,,))
$(eval $(call IMG2SP, CONVERT, assets/hero_u0.png, 8, 12, sprite_hero_u0,,))
$(eval $(call IMG2SP, CONVERT, assets/hero_d0.png, 8, 12, sprite_hero_d0,,))
$(eval $(call IMG2SP, CONVERT, assets/hero_r1.png, 8, 12, sprite_hero_r1,,))
$(eval $(call IMG2SP, CONVERT, assets/hero_l1.png, 8, 12, sprite_hero_l1,,))
$(eval $(call IMG2SP, CONVERT, assets/hero_u1.png, 8, 12, sprite_hero_u1,,))
$(eval $(call IMG2SP, CONVERT, assets/hero_d1.png, 8, 12, sprite_hero_d1,,))
## Door sprites
$(eval $(call IMG2SP, CONVERT, assets/door_ov.png, 4, 16, sprite_door_ov,,))
$(eval $(call IMG2SP, CONVERT, assets/door_cv.png, 4, 16, sprite_door_cv,,))
$(eval $(call IMG2SP, CONVERT, assets/door_oh.png, 12, 8, sprite_door_oh,,))
$(eval $(call IMG2SP, CONVERT, assets/door_ch.png, 12, 8, sprite_door_ch,,))
$(eval $(call IMG2SP, CONVERT, assets/door_sov.png, 4, 16, sprite_door_sov,,))
$(eval $(call IMG2SP, CONVERT, assets/door_scv.png, 4, 16, sprite_door_scv,,))
$(eval $(call IMG2SP, CONVERT, assets/door_soh.png, 12, 8, sprite_door_soh,,))
$(eval $(call IMG2SP, CONVERT, assets/door_sch.png, 12, 8, sprite_door_sch,,))
## Terrain
$(eval $(call IMG2SP, CONVERT, assets/obstacle.png, 8, 16, sprite_obstacle,,))
$(eval $(call IMG2SP, CONVERT, assets/spike.png, 8, 16, sprite_spike,,))
## Misc
$(eval $(call IMG2SP, CONVERT, assets/heart.png, 8, 10, sprite_heart,,))
$(eval $(call IMG2SP, CONVERT, assets/ChicagosBird.png, 12, 13, sprite_ChicagosBird,,))

## Numbers
$(eval $(call IMG2SP, CONVERT, assets/0.png, 4, 10, sprite_0,,))
$(eval $(call IMG2SP, CONVERT, assets/1.png, 4, 10, sprite_1,,))
$(eval $(call IMG2SP, CONVERT, assets/2.png, 4, 10, sprite_2,,))
$(eval $(call IMG2SP, CONVERT, assets/3.png, 4, 10, sprite_3,,))
$(eval $(call IMG2SP, CONVERT, assets/4.png, 4, 10, sprite_4,,))
$(eval $(call IMG2SP, CONVERT, assets/5.png, 4, 10, sprite_5,,))
$(eval $(call IMG2SP, CONVERT, assets/6.png, 4, 10, sprite_6,,))
$(eval $(call IMG2SP, CONVERT, assets/7.png, 4, 10, sprite_7,,))
$(eval $(call IMG2SP, CONVERT, assets/8.png, 4, 10, sprite_8,,))
$(eval $(call IMG2SP, CONVERT, assets/9.png, 4, 10, sprite_9,,))
$(eval $(call IMG2SP, CONVERT, assets/separator.png, 2, 10, sprite_sep,,))
## Big numbers
$(eval $(call IMG2SP, CONVERT, assets/b0.png, 10, 26, sprite_b0,,))
$(eval $(call IMG2SP, CONVERT, assets/b1.png, 10, 26, sprite_b1,,))
$(eval $(call IMG2SP, CONVERT, assets/b2.png, 10, 26, sprite_b2,,))
$(eval $(call IMG2SP, CONVERT, assets/b3.png, 10, 26, sprite_b3,,))
$(eval $(call IMG2SP, CONVERT, assets/b4.png, 10, 26, sprite_b4,,))
$(eval $(call IMG2SP, CONVERT, assets/b5.png, 10, 26, sprite_b5,,))
$(eval $(call IMG2SP, CONVERT, assets/b6.png, 10, 26, sprite_b6,,))
$(eval $(call IMG2SP, CONVERT, assets/b7.png, 10, 26, sprite_b7,,))
$(eval $(call IMG2SP, CONVERT, assets/b8.png, 10, 26, sprite_b8,,))
$(eval $(call IMG2SP, CONVERT, assets/b9.png, 10, 26, sprite_b9,,))
$(eval $(call IMG2SP, CONVERT, assets/bseparator.png, 4, 26, sprite_bsep,,))

## Text
$(eval $(call IMG2SP, CONVERT, assets/leveltext.png, 54, 26, sprite_level,,))
$(eval $(call IMG2SP, CONVERT, assets/gameover.png, 92, 26, sprite_gameover,,))
$(eval $(call IMG2SP, CONVERT, assets/playagain.png, 42, 12, sprite_playagain,,))
$(eval $(call IMG2SP, CONVERT, assets/youwin.png, 88, 26, sprite_youwin,,))

# Enemies
$(eval $(call IMG2SP, CONVERT, assets/enemy_melee1.png, 8, 12, sprite_melee1,,))
$(eval $(call IMG2SP, CONVERT, assets/enemyrangeddl.png, 8, 12, sprite_enemyrangeddl,,))
$(eval $(call IMG2SP, CONVERT, assets/enemyrangeddr.png, 8, 12, sprite_enemyrangeddr,,))
$(eval $(call IMG2SP, CONVERT, assets/enemyrangedul.png, 8, 12, sprite_enemyrangedul,,))
$(eval $(call IMG2SP, CONVERT, assets/enemyrangedur.png, 8, 12, sprite_enemyrangedur,,))
$(eval $(call IMG2SP, CONVERT, assets/enemyrangedlr.png, 8, 12, sprite_enemyrangedlr,,))
$(eval $(call IMG2SP, CONVERT, assets/enemyrangeddu.png, 8, 12, sprite_enemyrangeddu,,))
$(eval $(call IMG2SP, CONVERT, assets/enemywallup.png, 8, 12, sprite_enemywallup,,))
$(eval $(call IMG2SP, CONVERT, assets/enemywalldown.png, 8, 12, sprite_enemywalldown,,))
$(eval $(call IMG2SP, CONVERT, assets/enemywallright1.png, 8, 12, sprite_enemywallright,,))
$(eval $(call IMG2SP, CONVERT, assets/enemywallleft1.png, 8, 12, sprite_enemywallleft,,))
$(eval $(call IMG2SP, CONVERT, assets/ranged1down.png, 8, 12, sprite_ranged1down,,))
$(eval $(call IMG2SP, CONVERT, assets/ranged1right.png, 8, 12, sprite_ranged1right,,))
$(eval $(call IMG2SP, CONVERT, assets/ranged1up.png, 8, 12, sprite_ranged1up,,))
$(eval $(call IMG2SP, CONVERT, assets/ranged1left.png, 8, 12, sprite_ranged1left,,))
$(eval $(call IMG2SP, CONVERT, assets/ranged4.png, 8, 12, sprite_ranged4,,))
$(eval $(call IMG2SP, CONVERT, assets/enemy_esp.png, 8, 12, sprite_esp,,))

## Menu
$(eval $(call IMG2SP, SET_IMG_FORMAT, screen))
$(eval $(call IMG2SP, SET_OUTPUT, bin))
$(eval $(call IMG2SP, CONVERT, assets/menu.png, 160, 200, screen_menu,,))

## Tiles
$(eval $(call IMG2SP, SET_FOLDER, src/tilemaps/))
$(eval $(call IMG2SP, SET_IMG_FORMAT, zgtiles))
$(eval $(call IMG2SP, SET_OUTPUT, bin))
$(eval $(call IMG2SP, CONVERT, assets/tileset.png, 8, 8, tiles,))

##
## OLD MACROS (For compatibility)
##

## Example firmware palette definition as variable in cpct_img2tileset format

# PALETTE={0 1 3 4 7 9 10 12 13 16 19 20 21 24 25 26}

## AUTOMATED IMAGE CONVERSION EXAMPLE (Uncomment EVAL line to use)
##
##    This example would convert img/example.png into src/example.{c|h} files.
##    A C-array called pre_example[24*12*2] would be generated with the definition
##    of the image example.png in mode 0 screen pixel format, with interlaced mask.
##    The palette used for conversion is given through the PALETTE variable and
##    a pre_palette[16] array will be generated with the 16 palette colours as 
##	  hardware colour values.

# $(eval $(call IMG2SPRITES,assets/board.png,0,sprite,90,180,$(PALETTE),,src/sprites,hwpalette))



############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macro used for conversion is IMG2SPRITES, which has up to 9 parameters:##
##  (1): Image file to be converted into C sprite (PNG, JPG, GIF, etc)    ##
##  (2): Graphics mode (0,1,2) for the generated C sprite                 ##
##  (3): Prefix to add to all C-identifiers generated                     ##
##  (4): Width in pixels of each sprite/tile/etc that will be generated   ##
##  (5): Height in pixels of each sprite/tile/etc that will be generated  ##
##  (6): Firmware palette used to convert the image file into C values    ##
##  (7): (mask / tileset / zgtiles)                                       ##
##     - "mask":    generate interlaced mask for all sprites converted    ##
##     - "tileset": generate a tileset array with pointers to all sprites ##
##     - "zgtiles": generate tiles/sprites in Zig-Zag pixel order and     ##
##                  Gray Code row order                                   ##
##  (8): Output subfolder for generated .C/.H files (in project folder)   ##
##  (9): (hwpalette)                                                      ##
##     - "hwpalette": output palette array with hardware colour values    ##
## (10): Aditional options (you can use this to pass aditional modifiers  ##
##       to cpct_img2tileset)                                             ##
##                                                                        ##
## Macro is used in this way (one line for each image to be converted):   ##
##  $(eval $(call IMG2SPRITES,(1),(2),(3),(4),(5),(6),(7),(8),(9), (10))) ##
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##                                                                        ##
##  * You can omit parameters but leaving them empty. Therefore, if you   ##
##  wanted to specify an output folder but do not want your sprites to    ##
##  have mask and/or tileset, you may omit parameter (7) leaving it empty ##
##     $(eval $(call IMG2SPRITES,imgs/1.png,0,g,4,8,$(PAL),,src/))        ##
############################################################################
