.area _DATA
.area _CODE

.include "game.h.s"
.include "drawer.h.s"
.include "hero.h.s"
.include "bullet.h.s"
.include "timer.h.s"
.include "models/bullet.h.s"
.include "models/hero.h.s"
.include "models/room.h.s"
.include "cpctelera.h.s"

.globl _sprite_melee1

.macro ReserveEnemies
	.rept 8
		DefineDefaultEnemy #0
	.endm
	.db #255
.endm

enemies::
	ReserveEnemies

n_enemies:
	.db #0

health::
	.db #3

status_mele:
	.db #1

pause_mele::
	.db #5

counter_pause_mele:
	.db #5

pause_ranged::
	.db #70

counter_pause_ranged:
	.db #70

go_melee:
	.db #1

go_ranged:
	.db #1

controlEnemy::
	control_pause_mele:
		ld a, (counter_pause_mele)
		dec a
		jp z, reset_pause_mele
		ld (counter_pause_mele), a
		ld a, #0
		ld (go_melee), a
		jp control_pause_ranged
	reset_pause_mele:
		ld a, (pause_mele)
		ld (counter_pause_mele), a
		ld a, #1
		ld (go_melee), a

	control_pause_ranged:
		ld a, (counter_pause_ranged)
		dec a
		jp z, reset_pause_ranged
		ld (counter_pause_ranged), a
		ld a, #0
		ld (go_ranged), a
		jp start_controlEnemy
	reset_pause_ranged:
		ld a, (pause_ranged)
		ld (counter_pause_ranged), a
		ld a, #1
		ld (go_ranged), a

	start_controlEnemy:
		ld a, #0
		ld (n_enemies), a
		ld ix, #enemies
	loop_controlEnemy:
		ld a, 0(ix)
		cp #255
		jp z, finish_controlEnemy

		ld a, en_hp(ix)
		cp a, #0
		jp z, next_controlEnemy

		ld a, (n_enemies)
		inc a
		ld (n_enemies), a

		ld a, en_ty(ix)
	Enemy1:
		dec a
		jp nz, Enemy2
		ld a, (go_melee)
		dec a
		jp nz, continue_controlEnemy
		call melee_hor
		call melee_ver
		jp continue_controlEnemy
	Enemy2:
		dec a
		jp nz, Enemy3
		ld a, (go_ranged)
		dec a
		jp nz, continue_controlEnemy
		call enemy_shootUp
		jp continue_controlEnemy
	Enemy3:
		dec a
		jp nz, Enemy4
		ld a, (go_ranged)
		dec a
		jp nz, continue_controlEnemy
		call enemy_shootRight
		jp continue_controlEnemy
	Enemy4:
		dec a
		jp nz, Enemy5
		ld a, (go_ranged)
		dec a
		jp nz, continue_controlEnemy
		call enemy_shootDown
		jp continue_controlEnemy
	Enemy5:
		dec a
		jp nz, Enemy6
		ld a, (go_ranged)
		dec a
		jp nz, continue_controlEnemy
		call enemy_shootLeft
		jp continue_controlEnemy
	Enemy6:
		dec a
		jp nz, Enemy7
		ld a, (go_ranged)
		dec a
		jp nz, continue_controlEnemy
		call enemy_shootUp
		call enemy_shootDown
		jp continue_controlEnemy
	Enemy7:
		dec a
		jp nz, Enemy8
		ld a, (go_ranged)
		dec a
		jp nz, continue_controlEnemy
		call enemy_shootRight
		call enemy_shootLeft
		jp continue_controlEnemy
	Enemy8:
		dec a
		jp nz, Enemy9
		ld a, (go_ranged)
		dec a
		jp nz, continue_controlEnemy
		call enemy_shootUp
		call enemy_shootRight
		jp continue_controlEnemy
	Enemy9:
		dec a
		jp nz, Enemy10
		ld a, (go_ranged)
		dec a
		jp nz, continue_controlEnemy
		call enemy_shootDown
		call enemy_shootRight
		jp continue_controlEnemy
	Enemy10:
		dec a
		jp nz, Enemy11
		ld a, (go_ranged)
		dec a
		jp nz, continue_controlEnemy
		call enemy_shootDown
		call enemy_shootLeft
		jp continue_controlEnemy
	Enemy11:
		dec a
		jp nz, Enemy12
		ld a, (go_ranged)
		dec a
		jp nz, continue_controlEnemy
		call enemy_shootUp
		call enemy_shootLeft
		jp continue_controlEnemy
	Enemy12:
		dec a
		jp nz, Enemy13
		ld a, (go_ranged)
		dec a
		jp nz, continue_controlEnemy
		call enemy_shootUp
		call enemy_shootDown
		call enemy_shootRight
		call enemy_shootLeft
		jp continue_controlEnemy
	Enemy13:
		dec a
		jp nz, Enemy14
		Enemy13_mov:
			ld a, (go_melee)
			dec a
			jp nz, Enemy13_sht
			call melee_hor
		Enemy13_sht:
			ld a, (go_ranged)
			dec a
			jp nz, continue_controlEnemy
			ld iy, #hero
			ld a, e_y(iy)
			cp a, e_y(ix)
			jp nz, Enemy13_sht2
			call enemy_shootLeft
			call enemy_shootRight
			jp continue_controlEnemy
		Enemy13_sht2:
			call enemy_shootDown
		jp continue_controlEnemy
	Enemy14:
		dec a
		jp nz, Enemy15
		Enemy14_mov:
			ld a, (go_melee)
			dec a
			jp nz, Enemy14_sht
			call melee_hor
		Enemy14_sht:
			ld a, (go_ranged)
			dec a
			jp nz, continue_controlEnemy
			ld iy, #hero
			ld a, e_y(iy)
			cp a, e_y(ix)
			jp nz, Enemy14_sht2
			call enemy_shootLeft
			call enemy_shootRight
			jp continue_controlEnemy
		Enemy14_sht2:
			call enemy_shootUp
		jp continue_controlEnemy
	Enemy15:
		dec a
		jp nz, Enemy16
		Enemy15_mov:
			ld a, (go_melee)
			dec a
			jp nz, Enemy15_sht
			call melee_ver
		Enemy15_sht:
			ld a, (go_ranged)
			dec a
			jp nz, continue_controlEnemy
			ld iy, #hero
			ld a, e_x(iy)
			cp a, e_x(ix)
			jp nz, Enemy15_sht2
			call enemy_shootUp
			call enemy_shootDown
			jp continue_controlEnemy
		Enemy15_sht2:
			call enemy_shootLeft
		jp continue_controlEnemy
	Enemy16:
		dec a
		jp nz, Enemy17
		Enemy16_mov:
			ld a, (go_melee)
			dec a
			jp nz, continue_controlEnemy
			call melee_ver
		Enemy16_sht:
			ld a, (go_ranged)
			dec a
			jp nz, continue_controlEnemy
			ld iy, #hero
			ld a, e_x(iy)
			cp a, e_x(ix)
			jp nz, Enemy16_sht2
			call enemy_shootUp
			call enemy_shootDown
			jp continue_controlEnemy
		Enemy16_sht2:
			call enemy_shootRight
		jp continue_controlEnemy
	Enemy17:
		call openDoors
		ld a, #3
		Enemy17_loop:
			halt
			dec a
  			jp nz, Enemy17_loop
		
	
	continue_controlEnemy:
		call hero_collision

	next_controlEnemy:
		ld bc, #en_size
		add ix, bc
		jp loop_controlEnemy

	finish_controlEnemy:
		ld a, (n_enemies)
		cp a, #0
		jp z, openDoors
		ret

melee_hor:
		ld iy, #hero
		ld a, e_x(iy)
		cp a, e_x(ix)
		ret z
		jp m, l_beh
	r_beh:
		jp moveEnemyRight
	l_beh:
		jp moveEnemyLeft

melee_ver:
		ld iy, #hero
		ld a, e_y(ix)
		cp a, #0
		jp m, enemy_neg
		jp enemy_pos
	v_beh_continue:
		cp a, e_y(ix)
		ret z
		jp p, d1_beh
		u1_beh:
			jp moveEnemyUp
		d1_beh:
			jp moveEnemyDown
	enemy_neg::
		ld iy, #hero
		ld a, e_y(iy)
		cp a, #0
		jp p, moveEnemyUp
		jp v_beh_continue
	enemy_pos:
		ld iy, #hero
		ld a, e_y(iy)
		cp a, #0
		jp m, moveEnemyDown
		jp v_beh_continue

loadEnemy::
	ld a, #60
	ld (counter_pause_mele), a
	ld a, #60
	ld (counter_pause_ranged), a
	call getRoom
	ld l, r_pt_l(iy)
	ld h, r_pt_h(iy)
	push hl
	pop ix
	loop1_loadEnemy:
		ld a, 0(ix)
		cp a, #255
		jp z, continue1
		ld bc, #e_size
		add ix, bc
		jp loop1_loadEnemy
	continue1:
		inc ix
	loop2_loadEnemy:
		ld a, 0(ix)
		cp a, #255
		jp z, continue2
		ld bc, #e_size
		add ix, bc
		jp loop2_loadEnemy
	continue2:
		inc ix
		ld iy, #enemies
	loop3_loadEnemy:
		ld a, 0(ix)
		cp a, #255
		ret z
		ld a, e_x(ix)
		ld e_x(iy), a
		ld a, e_y(ix)
		ld e_y(iy), a
		ld a, en_pSpr_l(ix)
		ld en_pSpr_l(iy), a
		ld a, en_pSpr_h(ix)
		ld en_pSpr_h(iy), a
		ld a, en_ox(ix)
		ld en_ox(iy), a
		ld a, en_oy(ix)
		ld en_oy(iy), a
		ld a, (health)
		ld en_hp(iy), a
		ld a, en_ty(ix)
		ld en_ty(iy), a
		ld bc, #en_size
		add ix, bc
		add iy, bc
		jp loop3_loadEnemy

moveEnemyUp:
	ld b, e_x(ix)
	ld a, e_y(ix)
	cp a, #rd_upl
	ret z
	sub a, #4
	ld c, a
	call collision
	ld e_y(ix), c
	ret

moveEnemyDown::
	ld b, e_x(ix)
	ld a, e_y(ix)
	ld c, a
	add a, #12
	cp a, #rd_lol
	ret z
	ld a, c
	add a, #4
	ld c, a
	call collision
	ld e_y(ix), c
	ret

moveEnemyRight:
	ld a, e_x(ix)
	ld c, e_y(ix)
	ld b, a
	add a, #3
	cp a, #rd_ril
	ret z
	ld a, b
	inc a
	ld b, a
	call collision
	ld e_x(ix), b
	ret

moveEnemyLeft:
	ld a, e_x(ix)
	ld c, e_y(ix)
	cp a, #rd_lel
	ret z
	dec a
	ld b, a
	call collision
	ld e_x(ix), b
	ret

status:
	.db #0

hero_collision:
	ld a, (hero_inv)
	cp a, #1
	ret z
	ld b, e_x(ix)
	ld c, e_y(ix)
	ld a, b ;; X1
	add a, e_w(ix)
	ld d, a ;; X2
	ld a, c ;; Y1
	add a, e_h(ix)
	ld e, a ;; Y2
	ld iy, #hero
	xhorizontal1:
		ld a, e_x(iy)
		sub a, b
		jp z, xvertical1
		jp m, xhorizontal11
	xhorizontal2:
		ld a, e_x(iy)
		sub a, d
		jp m, xhorizontal22
		ret
	xvertical1:
		ld a, e_y(iy)
		sub a, c
		jp z, xcollided
		jp m, xvertical11
	xvertical2:
		ld a, e_y(iy)
		sub a, e
		jp m, xvertical22
		ret
	xhorizontal11:
		add a, #3
		jp m, xhorizontal2
		jp xvertical1
	xhorizontal22:
		add a, #3
		ret m
		jp xvertical1
	xvertical11:
		add a, #11
		jp m, xvertical2
		jp xcollided
	xvertical22:
		add a, #11
		ret m
	xcollided:
		push af
		push ix
		push iy
		ld l, #01
		ld h, #15
		ld e, #58
		ld d, #01
		ld bc, #0000
		ld a, #0b00000100
		call cpct_akp_SFXPlay_asm
		pop iy
		pop ix
		pop af
		ld a, #30
		ld (counter_pause_mele), a
		ld (hero_inv_counter), a
		ld a, #1
		ld (hero_inv), a
		ld a, h_hp(iy)
		dec a
		ld h_hp(iy), a
		ret

collision:
	push bc
	call getRoom
	pop bc
	ld a, #0
	ld (status), a
	ld a, b ;; X1
	add a, e_w(ix)
	ld d, a ;; X2
	ld a, c ;; Y1
	add a, e_h(ix)
	ld e, a ;; Y2
	ld l, r_pt_l(iy)
	ld h, r_pt_h(iy)
	push hl
	pop iy
	loop_vc:
		ld a, 0(iy)
		cp a, #255
		jp z, set_spike
	horizontal1:
		ld a, e_x(iy)
		sub a, b
		jp z, vertical1
		jp m, horizontal11
	horizontal2:
		ld a, e_x(iy)
		sub a, d
		jp m, horizontal22
		jp next_vc
	vertical1:
		ld a, e_y(iy)
		sub a, c
		jp m, vertical11
	vertical2:
		ld a, e_y(iy)
		sub a, e
		jp m, vertical22
	next_vc:
		push bc
		ld bc, #e_size
		add iy, bc
		pop bc
		jp loop_vc
	horizontal11:
		add a, e_w(iy)
		dec a
		jp m, horizontal2
		jp vertical1
	horizontal22:
		add a, e_w(iy)
		dec a
		jp m, next_vc
		jp vertical1
	vertical11:
		add a, e_h(iy)
		dec a
		jp m, vertical2
		jp collided
	vertical22:
		add a, e_h(iy)
		dec a
		jp m, next_vc
	collided:
		jp enemy_obstacle_collision
	set_spike:
		ld a, (status)
		cp a, #0
		ret nz
		inc a
		ld (status), a
		inc iy
		jp loop_vc

enemy_shootUp:
	call enemy_findBullet
	ld a, e_x(ix)
	inc a
	ld b_x(iy), a
	ld a, e_y(ix)
	add a, #4
	and a, #0b11111100
	ld b_y(iy), a
	ld a, #2
	ld b_di(iy), a
	jp enemy_enableBullet
enemy_shootDown:
	call enemy_findBullet
	ld a, e_x(ix)
	inc a
	ld b_x(iy), a
	ld a, e_y(ix)
	add a, #8
	and a, #0b11111100
	ld b_y(iy), a
	ld a, #4
	ld b_di(iy), a
	jp enemy_enableBullet
enemy_shootRight:
	call enemy_findBullet
	ld a, e_x(ix)
	add a, #3
	ld b_x(iy), a
	ld a, e_y(ix)
	add a, #4
	and a, #0b11111100
	ld b_y(iy), a
	ld a, #3
	ld b_di(iy), a
	jp enemy_enableBullet
enemy_shootLeft:
	call enemy_findBullet
	ld a, e_x(ix)
	inc a
	ld b_x(iy), a
	ld a, e_y(ix)
	add a, #4
	and a, #0b11111100
	ld b_y(iy), a
	ld a, #5
	ld b_di(iy), a
	jp enemy_enableBullet

enemy_enableBullet:
	ld a, #2
	ld b_st(iy), a
	ld a, b_x(iy)
	ld b_ox(iy), a
	ld a, b_y(iy)
	ld b_oy(iy), a
	ld a, #0
	ld b_si(iy), a
	ret

enemy_findBullet:
	ld iy, #bullets
	loop_findBullet:
		ld a, 0(iy)
		cp a, #255
		jp z, not_findBullet
		ld a, b_st(iy)
		cp a, #0
		ret z
	next_findBullet:
		ld bc, #b_size
		add iy, bc
		jp loop_findBullet
	not_findBullet:
		pop hl
		ret

enemy_obstacle_collision:
	pop hl
	ret

disableEnemy::
	ld ix, #enemies
	loop_disableEnemey:
		ld a, 0(ix)
		cp a, #255
		ret z
		ld a, #0
		ld en_hp(ix), a
		ld bc, #en_size
		add ix, bc
	jp loop_disableEnemey