;;-----------------------------LICENSE NOTICE-----------------------------------
;;  This file is part of Turtle Slam: An Amstrad CPC Game
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------

.include "models/spike.h.s"

.globl _sprite_melee1
.globl _sprite_ranged1up
.globl _sprite_ranged1down
.globl _sprite_ranged1right
.globl _sprite_ranged1left

.globl _sprite_enemyrangedur
.globl _sprite_enemyrangedul
.globl _sprite_enemyrangeddr
.globl _sprite_enemyrangeddl
.globl _sprite_enemyrangedlr
.globl _sprite_enemyrangeddu

.globl _sprite_ranged4

.globl _sprite_enemywallup
.globl _sprite_enemywalldown
.globl _sprite_enemywallright
.globl _sprite_enemywallleft

.globl _sprite_esp

.macro DefineDefaultEnemy _pspr
	DefineEntity 2, 96, 4, 12
		.dw #_pspr
		.db #2
		.db #96
		.db #0
		.db #1
.endm

.macro DefineEnemy _pspr, _x, _y, _t
	DefineEntity _x, _y, 4, 12
		.dw #_pspr
		.db #_x
		.db #_y
		.db #0
		.db #_t
.endm

.macro DefineMelee _x, _y
	DefineEnemy _sprite_melee1, _x, _y, 1
.endm

.macro DefineRanged2 _x, _y
	DefineEnemy _sprite_ranged1up, _x, _y, 2
.endm

.macro DefineRanged3 _x, _y
	DefineEnemy _sprite_ranged1right, _x, _y, 3
.endm

.macro DefineRanged4 _x, _y
	DefineEnemy _sprite_ranged1down, _x, _y, 4
.endm

.macro DefineRanged5 _x, _y
	DefineEnemy _sprite_ranged1left, _x, _y, 5
.endm

.macro DefineRanged6 _x, _y
	DefineEnemy _sprite_enemyrangeddu, _x, _y, 6
.endm

.macro DefineRanged7 _x, _y
	DefineEnemy _sprite_enemyrangedlr, _x, _y, 7
.endm

.macro DefineRanged8 _x, _y
	DefineEnemy _sprite_enemyrangedur, _x, _y, 8
.endm

.macro DefineRanged9 _x, _y
	DefineEnemy _sprite_enemyrangeddr, _x, _y, 9
.endm

.macro DefineRanged10 _x, _y
	DefineEnemy _sprite_enemyrangeddl, _x, _y, 10
.endm

.macro DefineRanged11 _x, _y
	DefineEnemy _sprite_enemyrangedul, _x, _y, 11
.endm

.macro DefineRanged12 _x, _y
	DefineEnemy _sprite_ranged4, _x, _y, 12
.endm

.macro DefineWallUp _x, _y
	DefineEnemy _sprite_enemywallup, _x, _y, 13
.endm

.macro DefineWallDown _x, _y
	DefineEnemy _sprite_enemywalldown, _x, _y, 14
.endm

.macro DefineWallRight _x, _y
	DefineEnemy _sprite_enemywallright, _x, _y, 15
.endm

.macro DefineWallLeft _x, _y
	DefineEnemy _sprite_enemywallleft, _x, _y, 16
.endm

.macro DefineEsp _x, _y
	DefineEnemy _sprite_esp, _x, _y, 17
.endm

en_pSpr = e_size + 0
	en_pSpr_l = e_size + 0
	en_pSpr_h = e_size + 1
en_ox = e_size + 2
en_oy = e_size + 3
en_hp = e_size + 4
en_ty = e_size + 5

en_size = e_size + 6