;;-----------------------------LICENSE NOTICE-----------------------------------
;;  This file is part of Turtle Slam: An Amstrad CPC Game
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------

.area _DATA
.area _CODE

timer:
    min::
        .db #0
    sec::
        .db #0
    tck1:
        .db #2
    tck2:
        .db #255

getSeed::
	ld a, (tck2)
    ld l, a
    ret

;; ============================================================================
;; Reset timer
;; Destroyed register values: A
;; ============================================================================
resetTimer::
	ld a, #3
	ld (refresh_sec), a
	ld (refresh_min), a
	dec a
	ld (tck1), a
	ld a, #255
	ld (tck2), a
	inc a
	ld (min), a
	ld (sec), a	
	ret

refresh_sec::
	.db #3

refresh_min::
	.db #3

;; ============================================================================
;; Tick
;; Destroyed register values: A
;; ============================================================================
tick::
nextTick2:
	ld a, (tck2)
	dec a
	jp z, nextTick1
	ld (tck2), a
	ret
nextTick1:
	ld a, (tck1)
	dec a
	jp z, nextSecond
	ld (tck1), a
	ld a, #45
	ld (tck2), a
	ret
nextSecond:
	ld a, #3
	ld (refresh_sec), a
	dec a
	ld (tck1), a
	ld a, #255
	ld (tck2), a
	ld a, (sec)
	inc a
	cp a, #60
	jp p, nextMinute
	ld (sec), a
	ret
nextMinute:
	ld a, #0
	ld (sec), a
	ld a, #3
	ld (refresh_min), a
	ld a, (min)
	inc a
	ld (min), a
	ret