;;-----------------------------LICENSE NOTICE-----------------------------------
;;  This file is part of Turtle Slam: An Amstrad CPC Game
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------

.area _DATA
.area _CODE

.include "cpctelera.h.s"

ptrVideo::
    .dw #0x8000

;; ============================================================================
;; Switch buffers
;; Destroyed register values: AF, BC, HL
;; ============================================================================
switchBuffers::
    ;; Change video memory page
    modifier = .+1
    ld l, #0x20
    call cpct_setVideoMemoryPage_asm
    ld hl, #modifier
    ld a, #0x10
    xor (hl)
    ld (modifier), a
    ;; Change video memory pointer
    ld hl, #ptrVideo+1
    ld a, #0x40
    xor (hl)
    ld (ptrVideo+1), a
    ret

;; ============================================================================
;; Initialize second buffer
;; Destroyed register values: BC, DE, HL
;; ============================================================================
initializeBuffer::
    ld hl, (ptrVideo)
    ld d, h
    ld e, #1
    ld (hl), #0
    ld bc, #0x3FFF
    ldir
    ret

fade::
	ld hl, (ptrVideo)
    ld d, h
    ld e, #1
    ld (hl), #0b11000000
    ld bc, #0x3FFF
	ldir
	call cpct_waitVSYNC_asm
	ld l, #16
    ld h, #0x54
    call cpct_setPALColour_asm
	call switchBuffers
	ret

unfade::
	ld l, #16
    ld h, #6
    call cpct_setPALColour_asm
	ret